function matlab_contrastenhancement(...
    Ic_in, Ig_in, Ig_base, alpha, gamma, ...
    name_Ic_out, name_Ig_detail, name_Ig_base, name_Ig_out)

alpha           = str2double(alpha);
gamma           = str2double(gamma);

Ig_in           = double(imread(Ig_in));
Ig_base         = double(imread(Ig_base));
Ig_detail       = Ig_in - Ig_base;

Ig_base_mod     = 255*((Ig_base/255).^(1/gamma));   clear Ig_base;
Ig_detail_mod   = alpha*Ig_detail;                  clear Ig_detail;
Ig_out          = Ig_base_mod + Ig_detail_mod;

fprintf('Writting %s ...',name_Ig_base);
imwrite(uint8(Ig_base_mod),name_Ig_base);           clear Ig_base_mod;
fprintf('ok\n');
fprintf('Writting %s ...',name_Ig_detail);
imwrite(uint8(128 + Ig_detail_mod),name_Ig_detail); clear Ig_detail_mod;
fprintf('ok\n');

Ig_out          = 255*SimplestColorBalance(Ig_out/255,.001,.001);

contrast_coeffs = Ig_out./Ig_in;                    clear Ig_in;

fprintf('Writting %s ...',name_Ig_out);
imwrite(uint8(Ig_out),name_Ig_out);                 clear Ig_out;
fprintf('ok\n');

Ic_in           = double(imread(Ic_in));
Ic_out          = zeros(size(Ic_in));
Ic_out(:,:,1)   = Ic_in(:,:,1).*contrast_coeffs;
Ic_out(:,:,2)   = Ic_in(:,:,2).*contrast_coeffs;
Ic_out(:,:,3)   = Ic_in(:,:,3).*contrast_coeffs;

% %%% In the clipped zones (color image) %%%
% I_max           = max(255,max(Ic_out,[],3));
% Ic_out(:,:,1)   = 255*Ic_out(:,:,1)./I_max;
% Ic_out(:,:,2)   = 255*Ic_out(:,:,2)./I_max;
% Ic_out(:,:,3)   = 255*Ic_out(:,:,3)./I_max;         clear I_max;
% %%% There is no need to do this because the Simplest Color Balance   %%%
% %%% does the job already: after it there are hardly no clipped px.   %%%

fprintf('Writting %s ...',name_Ic_out);
imwrite(uint8(Ic_out),name_Ic_out);                 clear Ic_in Ic_out;
fprintf('ok\n');
end