function Iout = SimplestColorBalance(Iin,k_clip,w_clip)
% Iout = SimplestColorBalance(Iin,k_clip,w_clip)
% L'image Iin doit tre dans [0,1]
% Le 16 juillet 2015, CMLA
% D'aprs l'article d'IPOL du mme nom

[H,X]    = hist(Iin(:),256);
histocum = cumsum(H(:));
N        = numel(Iin);
[~,imax] = max(histocum >= round((1-w_clip)*N));
[~,imin] = max(histocum >= round((0+k_clip)*N));
vmax     = X(imax);
vmin     = X(imin);

Iout     = (Iin-vmin)/(vmax - vmin);

% Saturation : 
Iout(Iout > 1) = 1;
Iout(Iout < 0) = 0;

% vrification :
fprintf('--- Simplest Color Balance ---\n');
fprintf('Nb of white clipped px : %2.1f %%\n', 100*sum(Iout(:) == 1)/N);
fprintf('Nb of black clipped px : %2.1f %%\n', 100*sum(Iout(:) == 0)/N);
fprintf('------------------------------\n');

end