function matlab_multigrain(input_gray,sigma_s,sigma_r,base,...
                       grain1,size1,...
                       grain2,size2,...
                       grain3,size3,...
                       grain4,size4,...
                       grain5,size5,...
                       grain6,size6,...
                       grain7,size7,...
                       grain8,size8,...
                       grain9,size9)

sigma_s     = str2double(sigma_s);
sigma_r     = str2double(sigma_r);
size1       = str2double(size1);
size2       = str2double(size2);
size3       = str2double(size3);
size4       = str2double(size4);
size5       = str2double(size5);
size6       = str2double(size6);
size7       = str2double(size7);
size8       = str2double(size8);
size9       = str2double(size9);

input       = imread(input_gray);
input       = double(input);

grain1      = double(imread(grain1));
grain2      = double(imread(grain2));
grain3      = double(imread(grain3));
grain4      = double(imread(grain4));
grain5      = double(imread(grain5));
grain6      = double(imread(grain6));
grain7      = double(imread(grain7));
grain8      = double(imread(grain8));
grain9      = double(imread(grain9));

weightfunspace = @(A)(exp( -A   /(2*sigma_s^2)));
weightfunrange = @(u)(exp( -u.^2/(2*sigma_r^2)));

Idet1 = (input  - grain1);
Idet2 = (grain1 - grain2);
Idet3 = (grain2 - grain3);
Idet4 = (grain3 - grain4);
Idet5 = (grain4 - grain5);
Idet6 = (grain5 - grain6);
Idet7 = (grain6 - grain7);
Idet8 = (grain7 - grain8);
Idet9 = (grain8 - grain9);

Idet  = Idet1*weightfunspace(size1).*weightfunrange(Idet1) ...
      + Idet2*weightfunspace(size2).*weightfunrange(Idet2) ...
      + Idet3*weightfunspace(size3).*weightfunrange(Idet3) ...
      + Idet4*weightfunspace(size4).*weightfunrange(Idet4) ...
      + Idet5*weightfunspace(size5).*weightfunrange(Idet5) ...
      + Idet6*weightfunspace(size6).*weightfunrange(Idet6) ...
      + Idet7*weightfunspace(size7).*weightfunrange(Idet7) ...
      + Idet8*weightfunspace(size8).*weightfunrange(Idet8) ...
      + Idet9*weightfunspace(size9).*weightfunrange(Idet9) ;

Ibase = input - Idet;

imwrite(uint8(Ibase),base);

end
